Attribute VB_Name = "modMain"
Option Explicit
Public Enum Code
    Win = 1
    Dos = 2
    Koi = 3
    Iso = 5
End Enum
Public Declare Function CreateCaret Lib "user32" (ByVal hwnd As Long, ByVal hBitmap As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function ShowCaret Lib "user32" (ByVal hwnd As Long) As Long
Public Progress As Long, Data As String, Reply As Long, OK As Boolean, Index As Long, m_strEncodedFiles As String, strSubject As String, strBody As String
Public Function UUEncodeFile(strFilePath As String) As String
    Rem  -  ,   "" 
    Dim intFile As Integer, intTempFile As Integer, lFileSize As Long, strFileName As String, strFileData As String, lEncodedLines As Long, strTempLine As String, i As Long, j As Integer, strResult As String
    strFileName = Mid$(strFilePath, InStrRev(strFilePath, "\") + 1)
    strResult = "begin 664 " + strFileName + vbLf
    lFileSize = FileLen(strFilePath)
    lEncodedLines = lFileSize \ 45 + 1
    strFileData = Space(45)
    intFile = FreeFile
    Open strFilePath For Binary As intFile
        For i = 1 To lEncodedLines
            If i = lEncodedLines Then
                strFileData = Space(lFileSize Mod 45)
            End If
            Get intFile, , strFileData
            strTempLine = Chr(Len(strFileData) + 32)
            If i = lEncodedLines And (Len(strFileData) Mod 3) Then
                strFileData = strFileData + Space(3 - (Len(strFileData) Mod 3))
            End If
            For j = 1 To Len(strFileData) Step 3
                strTempLine = strTempLine + Chr(Asc(Mid(strFileData, j, 1)) \ 4 + 32)
                strTempLine = strTempLine + Chr((Asc(Mid(strFileData, j, 1)) Mod 4) * 16 + Asc(Mid(strFileData, j + 1, 1)) \ 16 + 32)
                strTempLine = strTempLine + Chr((Asc(Mid(strFileData, j + 1, 1)) Mod 16) * 4 + Asc(Mid(strFileData, j + 2, 1)) \ 64 + 32)
                strTempLine = strTempLine + Chr(Asc(Mid(strFileData, j + 2, 1)) Mod 64 + 32)
            Next j
            strTempLine = Replace(strTempLine, " ", "`")
            strResult = strResult + strTempLine + vbLf
            strTempLine = ""
        Next i
    Close intFile
    strResult = strResult & "`" & vbLf + "end" + vbLf
    UUEncodeFile = strResult
End Function
Function Recode(Char As String, Src As Code, Dest As Code) As String
Rem   ,    
'http://www.vbrussian.com'
Const wDos As String = ""
Const wIso As String = "ע"
Const wKoi As String = ""
Const wWin As String = ""
Const NotRecodedChar As String = "?"

If Src = Dest Then
    Recode = Char
    Exit Function
End If

Dim t As String, i As Long, tt As String, a As Long, ss As String, ch As String
If Src = Win Then
    t = Char
Else
    Select Case Src
        Case Koi: ss = wKoi
        Case Dos: ss = wDos
        Case Iso: ss = wIso
    End Select
    For i = 1 To Len(Char)
        ch = Mid(Char, i, 1)
        If Asc(ch) < 128 Then
            t = t & ch
        Else
            a = InStr(1, ss, ch, vbBinaryCompare)
            If a = 0 Then
                t = t & NotRecodedChar
            Else
                t = t & Mid$(wWin, a, 1)
            End If
        End If
    Next i
End If

If Dest = Win Then
    Recode = t
Else
    Select Case Dest
        Case Koi: ss = wKoi
        Case Dos: ss = wDos
        Case Iso: ss = wIso
    End Select
    For i = 1 To Len(Char)
        ch = Mid(t, i, 1)
        If Asc(ch) < 128 Then
            tt = tt & ch
        Else
            a = InStr(1, wWin, ch, vbBinaryCompare)
            If a = 0 Then
                tt = tt & NotRecodedChar
            Else
                tt = tt & Mid$(ss, a, 1)
            End If
        End If
    Next i
    Recode = tt
End If
End Function

